import json
import setuptools

kwargs = json.loads(
    """
{
    "name": "cdktf-cdktf-provider-cloudflare",
    "version": "13.1.0",
    "description": "Prebuilt cloudflare Provider for Terraform CDK (cdktf)",
    "license": "MPL-2.0",
    "url": "https://github.com/cdktf/cdktf-provider-cloudflare.git",
    "long_description_content_type": "text/markdown",
    "author": "HashiCorp",
    "bdist_wheel": {
        "universal": true
    },
    "project_urls": {
        "Source": "https://github.com/cdktf/cdktf-provider-cloudflare.git"
    },
    "package_dir": {
        "": "src"
    },
    "packages": [
        "cdktf_cdktf_provider_cloudflare",
        "cdktf_cdktf_provider_cloudflare._jsii",
        "cdktf_cdktf_provider_cloudflare.access_rule",
        "cdktf_cdktf_provider_cloudflare.account",
        "cdktf_cdktf_provider_cloudflare.account_dns_settings",
        "cdktf_cdktf_provider_cloudflare.account_dns_settings_internal_view",
        "cdktf_cdktf_provider_cloudflare.account_member",
        "cdktf_cdktf_provider_cloudflare.account_subscription",
        "cdktf_cdktf_provider_cloudflare.account_token",
        "cdktf_cdktf_provider_cloudflare.address_map",
        "cdktf_cdktf_provider_cloudflare.api_shield",
        "cdktf_cdktf_provider_cloudflare.api_shield_discovery_operation",
        "cdktf_cdktf_provider_cloudflare.api_shield_operation",
        "cdktf_cdktf_provider_cloudflare.api_shield_operation_schema_validation_settings",
        "cdktf_cdktf_provider_cloudflare.api_shield_schema",
        "cdktf_cdktf_provider_cloudflare.api_shield_schema_validation_settings",
        "cdktf_cdktf_provider_cloudflare.api_token",
        "cdktf_cdktf_provider_cloudflare.argo_smart_routing",
        "cdktf_cdktf_provider_cloudflare.argo_tiered_caching",
        "cdktf_cdktf_provider_cloudflare.authenticated_origin_pulls",
        "cdktf_cdktf_provider_cloudflare.authenticated_origin_pulls_certificate",
        "cdktf_cdktf_provider_cloudflare.authenticated_origin_pulls_settings",
        "cdktf_cdktf_provider_cloudflare.bot_management",
        "cdktf_cdktf_provider_cloudflare.byo_ip_prefix",
        "cdktf_cdktf_provider_cloudflare.calls_sfu_app",
        "cdktf_cdktf_provider_cloudflare.calls_turn_app",
        "cdktf_cdktf_provider_cloudflare.certificate_pack",
        "cdktf_cdktf_provider_cloudflare.cloud_connector_rules",
        "cdktf_cdktf_provider_cloudflare.cloudforce_one_request",
        "cdktf_cdktf_provider_cloudflare.cloudforce_one_request_asset",
        "cdktf_cdktf_provider_cloudflare.cloudforce_one_request_message",
        "cdktf_cdktf_provider_cloudflare.cloudforce_one_request_priority",
        "cdktf_cdktf_provider_cloudflare.content_scanning_expression",
        "cdktf_cdktf_provider_cloudflare.custom_hostname",
        "cdktf_cdktf_provider_cloudflare.custom_hostname_fallback_origin",
        "cdktf_cdktf_provider_cloudflare.custom_pages",
        "cdktf_cdktf_provider_cloudflare.custom_ssl",
        "cdktf_cdktf_provider_cloudflare.d1_database",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_access_rule",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_access_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_api_token_permission_groups",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_api_token_permission_groups_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_dns_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_dns_settings_internal_view",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_dns_settings_internal_views",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_member",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_members",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_permission_group",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_permission_groups",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_role",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_roles",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_subscription",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_token",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_account_tokens",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_accounts",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_address_map",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_address_maps",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield_discovery_operations",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield_operation",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield_operation_schema_validation_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield_operations",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield_schema",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield_schema_validation_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_shield_schemas",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_token",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_token_permission_groups_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_api_tokens",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_argo_smart_routing",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_argo_tiered_caching",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_authenticated_origin_pulls",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_authenticated_origin_pulls_certificate",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_authenticated_origin_pulls_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_authenticated_origin_pulls_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_bot_management",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_botnet_feed_config_asn",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_byo_ip_prefix",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_byo_ip_prefixes",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_calls_sfu_app",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_calls_sfu_apps",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_calls_turn_app",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_calls_turn_apps",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_certificate_pack",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_certificate_packs",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_cloud_connector_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_cloudforce_one_request",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_cloudforce_one_request_asset",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_cloudforce_one_request_message",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_cloudforce_one_request_priority",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_cloudforce_one_requests",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_content_scanning_expressions",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_custom_hostname",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_custom_hostname_fallback_origin",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_custom_hostnames",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_custom_pages",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_custom_pages_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_custom_ssl",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_custom_ssls",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_d1_database",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_d1_databases",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dcv_delegation",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_firewall",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_firewalls",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_record",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_records",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_acl",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_acls",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_incoming",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_outgoing",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_peer",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_peers",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_tsig",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_dns_zone_transfers_tsigs",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_routing_address",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_routing_addresses",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_routing_catch_all",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_routing_dns",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_routing_rule",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_routing_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_routing_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_security_block_sender",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_security_block_senders",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_security_impersonation_registries",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_security_impersonation_registry",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_security_trusted_domains",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_email_security_trusted_domains_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_filter",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_filters",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_firewall_rule",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_firewall_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_healthcheck",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_healthchecks",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_hostname_tls_setting",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_hyperdrive_config",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_hyperdrive_configs",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_image",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_image_variant",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_images",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_ip_ranges",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_keyless_certificate",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_keyless_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_leaked_credential_check",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_leaked_credential_check_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_list_item",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_load_balancer",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_load_balancer_monitor",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_load_balancer_monitors",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_load_balancer_pool",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_load_balancer_pools",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_load_balancers",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_logpull_retention",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_logpush_dataset_field",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_logpush_dataset_job",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_logpush_job",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_logpush_jobs",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_network_monitoring_configuration",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_network_monitoring_rule",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_network_monitoring_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_connector",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_connectors",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_site",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_site_acl",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_site_acls",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_site_lan",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_site_lans",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_site_wan",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_site_wans",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_transit_sites",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_wan_gre_tunnel",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_wan_ipsec_tunnel",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_magic_wan_static_route",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_managed_transforms",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_mtls_certificate",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_mtls_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_notification_policies",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_notification_policy",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_notification_policy_webhooks",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_notification_policy_webhooks_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_observatory_scheduled_test",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_origin_ca_certificate",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_origin_ca_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_rule",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_connections",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_connections_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_cookies",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_cookies_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_policies",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_policy",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_scripts",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_page_shield_scripts_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_pages_domain",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_pages_domains",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_pages_project",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_pages_projects",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_queue",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_queue_consumer",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_queues",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_r2_bucket",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_r2_bucket_cors",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_r2_bucket_event_notification",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_r2_bucket_lifecycle",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_r2_bucket_lock",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_r2_bucket_sippy",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_r2_custom_domain",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_rate_limit",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_rate_limits",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_regional_hostname",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_regional_hostnames",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_regional_tiered_cache",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_registrar_domain",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_registrar_domains",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_resource_group",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_resource_groups",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_ruleset",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_rulesets",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_schema_validation_operation_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_schema_validation_operation_settings_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_schema_validation_schemas",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_schema_validation_schemas_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_schema_validation_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_snippet_rules_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_snippets",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_snippets_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_spectrum_application",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_spectrum_applications",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_audio_track",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_caption_language",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_download",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_key",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_live_input",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_watermark",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_watermarks",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_stream_webhook",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_streams",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_tiered_cache",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_total_tls",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_turnstile_widget",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_turnstile_widgets",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_url_normalization_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_user",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_user_agent_blocking_rule",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_user_agent_blocking_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_waiting_room",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_waiting_room_event",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_waiting_room_events",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_waiting_room_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_waiting_room_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_waiting_rooms",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_web_analytics_site",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_web_analytics_sites",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_web3_hostname",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_web3_hostnames",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_cron_trigger",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_custom_domain",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_custom_domains",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_deployment",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_for_platforms_dispatch_namespace",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_for_platforms_dispatch_namespaces",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_kv",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_kv_namespace",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_kv_namespaces",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_route",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_routes",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_script",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_script_subdomain",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_workers_scripts",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_application",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_applications",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_custom_page",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_custom_pages",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_group",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_groups",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_identity_provider",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_identity_providers",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_infrastructure_target",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_infrastructure_targets",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_key_configuration",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_mtls_certificate",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_mtls_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_mtls_hostname_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_policies",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_policy",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_service_token",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_service_tokens",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_short_lived_certificate",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_short_lived_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_tag",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_access_tags",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_custom_profile",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_custom_profile_local_domain_fallback",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_custom_profiles",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_default_profile",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_default_profile_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_default_profile_local_domain_fallback",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_managed_networks",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_managed_networks_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_posture_integration",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_posture_integrations",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_posture_rule",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_posture_rules",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_device_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dex_test",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dex_tests",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dlp_custom_profile",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dlp_dataset",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dlp_datasets",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dlp_entries",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dlp_entry",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dlp_predefined_profile",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dns_location",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_dns_locations",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_app_types_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_categories_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_certificate",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_certificates",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_logging",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_policies",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_policy",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_proxy_endpoint",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_gateway_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_list",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_lists",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_organization",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_risk_behavior",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_risk_scoring_integration",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_risk_scoring_integrations",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflared",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflared_config",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflared_route",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflared_routes",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflared_token",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflared_virtual_network",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflared_virtual_networks",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_cloudflareds",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zero_trust_tunnel_warp_connector_token",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_cache_reserve",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_cache_variants",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_dns_settings",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_dnssec",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_hold",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_lockdown",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_lockdowns",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_setting",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zone_subscription",
        "cdktf_cdktf_provider_cloudflare.data_cloudflare_zones",
        "cdktf_cdktf_provider_cloudflare.dns_firewall",
        "cdktf_cdktf_provider_cloudflare.dns_record",
        "cdktf_cdktf_provider_cloudflare.dns_zone_transfers_acl",
        "cdktf_cdktf_provider_cloudflare.dns_zone_transfers_incoming",
        "cdktf_cdktf_provider_cloudflare.dns_zone_transfers_outgoing",
        "cdktf_cdktf_provider_cloudflare.dns_zone_transfers_peer",
        "cdktf_cdktf_provider_cloudflare.dns_zone_transfers_tsig",
        "cdktf_cdktf_provider_cloudflare.email_routing_address",
        "cdktf_cdktf_provider_cloudflare.email_routing_catch_all",
        "cdktf_cdktf_provider_cloudflare.email_routing_dns",
        "cdktf_cdktf_provider_cloudflare.email_routing_rule",
        "cdktf_cdktf_provider_cloudflare.email_routing_settings",
        "cdktf_cdktf_provider_cloudflare.email_security_block_sender",
        "cdktf_cdktf_provider_cloudflare.email_security_impersonation_registry",
        "cdktf_cdktf_provider_cloudflare.email_security_trusted_domains",
        "cdktf_cdktf_provider_cloudflare.filter",
        "cdktf_cdktf_provider_cloudflare.firewall_rule",
        "cdktf_cdktf_provider_cloudflare.healthcheck",
        "cdktf_cdktf_provider_cloudflare.hostname_tls_setting",
        "cdktf_cdktf_provider_cloudflare.hyperdrive_config",
        "cdktf_cdktf_provider_cloudflare.image",
        "cdktf_cdktf_provider_cloudflare.image_variant",
        "cdktf_cdktf_provider_cloudflare.keyless_certificate",
        "cdktf_cdktf_provider_cloudflare.leaked_credential_check",
        "cdktf_cdktf_provider_cloudflare.leaked_credential_check_rule",
        "cdktf_cdktf_provider_cloudflare.list",
        "cdktf_cdktf_provider_cloudflare.list_item",
        "cdktf_cdktf_provider_cloudflare.load_balancer",
        "cdktf_cdktf_provider_cloudflare.load_balancer_monitor",
        "cdktf_cdktf_provider_cloudflare.load_balancer_pool",
        "cdktf_cdktf_provider_cloudflare.logpull_retention",
        "cdktf_cdktf_provider_cloudflare.logpush_job",
        "cdktf_cdktf_provider_cloudflare.logpush_ownership_challenge",
        "cdktf_cdktf_provider_cloudflare.magic_network_monitoring_configuration",
        "cdktf_cdktf_provider_cloudflare.magic_network_monitoring_rule",
        "cdktf_cdktf_provider_cloudflare.magic_transit_connector",
        "cdktf_cdktf_provider_cloudflare.magic_transit_site",
        "cdktf_cdktf_provider_cloudflare.magic_transit_site_acl",
        "cdktf_cdktf_provider_cloudflare.magic_transit_site_lan",
        "cdktf_cdktf_provider_cloudflare.magic_transit_site_wan",
        "cdktf_cdktf_provider_cloudflare.magic_wan_gre_tunnel",
        "cdktf_cdktf_provider_cloudflare.magic_wan_ipsec_tunnel",
        "cdktf_cdktf_provider_cloudflare.magic_wan_static_route",
        "cdktf_cdktf_provider_cloudflare.managed_transforms",
        "cdktf_cdktf_provider_cloudflare.mtls_certificate",
        "cdktf_cdktf_provider_cloudflare.notification_policy",
        "cdktf_cdktf_provider_cloudflare.notification_policy_webhooks",
        "cdktf_cdktf_provider_cloudflare.observatory_scheduled_test",
        "cdktf_cdktf_provider_cloudflare.origin_ca_certificate",
        "cdktf_cdktf_provider_cloudflare.page_rule",
        "cdktf_cdktf_provider_cloudflare.page_shield_policy",
        "cdktf_cdktf_provider_cloudflare.pages_domain",
        "cdktf_cdktf_provider_cloudflare.pages_project",
        "cdktf_cdktf_provider_cloudflare.provider",
        "cdktf_cdktf_provider_cloudflare.queue",
        "cdktf_cdktf_provider_cloudflare.queue_consumer",
        "cdktf_cdktf_provider_cloudflare.r2_bucket",
        "cdktf_cdktf_provider_cloudflare.r2_bucket_cors",
        "cdktf_cdktf_provider_cloudflare.r2_bucket_event_notification",
        "cdktf_cdktf_provider_cloudflare.r2_bucket_lifecycle",
        "cdktf_cdktf_provider_cloudflare.r2_bucket_lock",
        "cdktf_cdktf_provider_cloudflare.r2_bucket_sippy",
        "cdktf_cdktf_provider_cloudflare.r2_custom_domain",
        "cdktf_cdktf_provider_cloudflare.r2_managed_domain",
        "cdktf_cdktf_provider_cloudflare.rate_limit",
        "cdktf_cdktf_provider_cloudflare.regional_hostname",
        "cdktf_cdktf_provider_cloudflare.regional_tiered_cache",
        "cdktf_cdktf_provider_cloudflare.registrar_domain",
        "cdktf_cdktf_provider_cloudflare.ruleset",
        "cdktf_cdktf_provider_cloudflare.schema_validation_operation_settings",
        "cdktf_cdktf_provider_cloudflare.schema_validation_schemas",
        "cdktf_cdktf_provider_cloudflare.schema_validation_settings",
        "cdktf_cdktf_provider_cloudflare.snippet_rules",
        "cdktf_cdktf_provider_cloudflare.snippets",
        "cdktf_cdktf_provider_cloudflare.spectrum_application",
        "cdktf_cdktf_provider_cloudflare.stream",
        "cdktf_cdktf_provider_cloudflare.stream_audio_track",
        "cdktf_cdktf_provider_cloudflare.stream_caption_language",
        "cdktf_cdktf_provider_cloudflare.stream_download",
        "cdktf_cdktf_provider_cloudflare.stream_key",
        "cdktf_cdktf_provider_cloudflare.stream_live_input",
        "cdktf_cdktf_provider_cloudflare.stream_watermark",
        "cdktf_cdktf_provider_cloudflare.stream_webhook",
        "cdktf_cdktf_provider_cloudflare.tiered_cache",
        "cdktf_cdktf_provider_cloudflare.total_tls",
        "cdktf_cdktf_provider_cloudflare.turnstile_widget",
        "cdktf_cdktf_provider_cloudflare.url_normalization_settings",
        "cdktf_cdktf_provider_cloudflare.user",
        "cdktf_cdktf_provider_cloudflare.user_agent_blocking_rule",
        "cdktf_cdktf_provider_cloudflare.waiting_room",
        "cdktf_cdktf_provider_cloudflare.waiting_room_event",
        "cdktf_cdktf_provider_cloudflare.waiting_room_rules",
        "cdktf_cdktf_provider_cloudflare.waiting_room_settings",
        "cdktf_cdktf_provider_cloudflare.web_analytics_rule",
        "cdktf_cdktf_provider_cloudflare.web_analytics_site",
        "cdktf_cdktf_provider_cloudflare.web3_hostname",
        "cdktf_cdktf_provider_cloudflare.workers_cron_trigger",
        "cdktf_cdktf_provider_cloudflare.workers_custom_domain",
        "cdktf_cdktf_provider_cloudflare.workers_deployment",
        "cdktf_cdktf_provider_cloudflare.workers_for_platforms_dispatch_namespace",
        "cdktf_cdktf_provider_cloudflare.workers_kv",
        "cdktf_cdktf_provider_cloudflare.workers_kv_namespace",
        "cdktf_cdktf_provider_cloudflare.workers_route",
        "cdktf_cdktf_provider_cloudflare.workers_script",
        "cdktf_cdktf_provider_cloudflare.workers_script_subdomain",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_application",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_custom_page",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_group",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_identity_provider",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_infrastructure_target",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_key_configuration",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_mtls_certificate",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_mtls_hostname_settings",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_policy",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_service_token",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_short_lived_certificate",
        "cdktf_cdktf_provider_cloudflare.zero_trust_access_tag",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_custom_profile",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_custom_profile_local_domain_fallback",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_default_profile",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_default_profile_certificates",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_default_profile_local_domain_fallback",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_managed_networks",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_posture_integration",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_posture_rule",
        "cdktf_cdktf_provider_cloudflare.zero_trust_device_settings",
        "cdktf_cdktf_provider_cloudflare.zero_trust_dex_test",
        "cdktf_cdktf_provider_cloudflare.zero_trust_dlp_custom_profile",
        "cdktf_cdktf_provider_cloudflare.zero_trust_dlp_dataset",
        "cdktf_cdktf_provider_cloudflare.zero_trust_dlp_entry",
        "cdktf_cdktf_provider_cloudflare.zero_trust_dlp_predefined_profile",
        "cdktf_cdktf_provider_cloudflare.zero_trust_dns_location",
        "cdktf_cdktf_provider_cloudflare.zero_trust_gateway_certificate",
        "cdktf_cdktf_provider_cloudflare.zero_trust_gateway_logging",
        "cdktf_cdktf_provider_cloudflare.zero_trust_gateway_policy",
        "cdktf_cdktf_provider_cloudflare.zero_trust_gateway_proxy_endpoint",
        "cdktf_cdktf_provider_cloudflare.zero_trust_gateway_settings",
        "cdktf_cdktf_provider_cloudflare.zero_trust_list",
        "cdktf_cdktf_provider_cloudflare.zero_trust_organization",
        "cdktf_cdktf_provider_cloudflare.zero_trust_risk_behavior",
        "cdktf_cdktf_provider_cloudflare.zero_trust_risk_scoring_integration",
        "cdktf_cdktf_provider_cloudflare.zero_trust_tunnel_cloudflared",
        "cdktf_cdktf_provider_cloudflare.zero_trust_tunnel_cloudflared_config",
        "cdktf_cdktf_provider_cloudflare.zero_trust_tunnel_cloudflared_route",
        "cdktf_cdktf_provider_cloudflare.zero_trust_tunnel_cloudflared_virtual_network",
        "cdktf_cdktf_provider_cloudflare.zone",
        "cdktf_cdktf_provider_cloudflare.zone_cache_reserve",
        "cdktf_cdktf_provider_cloudflare.zone_cache_variants",
        "cdktf_cdktf_provider_cloudflare.zone_dns_settings",
        "cdktf_cdktf_provider_cloudflare.zone_dnssec",
        "cdktf_cdktf_provider_cloudflare.zone_hold",
        "cdktf_cdktf_provider_cloudflare.zone_lockdown",
        "cdktf_cdktf_provider_cloudflare.zone_setting",
        "cdktf_cdktf_provider_cloudflare.zone_subscription"
    ],
    "package_data": {
        "cdktf_cdktf_provider_cloudflare._jsii": [
            "provider-cloudflare@13.1.0.jsii.tgz"
        ],
        "cdktf_cdktf_provider_cloudflare": [
            "py.typed"
        ]
    },
    "python_requires": "~=3.9",
    "install_requires": [
        "cdktf>=0.21.0, <0.22.0",
        "constructs>=10.4.2, <11.0.0",
        "jsii>=1.112.0, <2.0.0",
        "publication>=0.0.3",
        "typeguard>=2.13.3,<4.3.0"
    ],
    "classifiers": [
        "Intended Audience :: Developers",
        "Operating System :: OS Independent",
        "Programming Language :: JavaScript",
        "Programming Language :: Python :: 3 :: Only",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: Python :: 3.11",
        "Typing :: Typed",
        "Development Status :: 5 - Production/Stable",
        "License :: OSI Approved"
    ],
    "scripts": []
}
"""
)

with open("README.md", encoding="utf8") as fp:
    kwargs["long_description"] = fp.read()


setuptools.setup(**kwargs)
