/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareBotManagementConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifier.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/bot_management#zone_id DataCloudflareBotManagement#zone_id}
    */
    readonly zoneId: string;
}
export interface DataCloudflareBotManagementStaleZoneConfiguration {
}
export declare function dataCloudflareBotManagementStaleZoneConfigurationToTerraform(struct?: DataCloudflareBotManagementStaleZoneConfiguration): any;
export declare function dataCloudflareBotManagementStaleZoneConfigurationToHclTerraform(struct?: DataCloudflareBotManagementStaleZoneConfiguration): any;
export declare class DataCloudflareBotManagementStaleZoneConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareBotManagementStaleZoneConfiguration | undefined;
    set internalValue(value: DataCloudflareBotManagementStaleZoneConfiguration | undefined);
    get fightMode(): cdktf.IResolvable;
    get optimizeWordpress(): cdktf.IResolvable;
    get sbfmDefinitelyAutomated(): string;
    get sbfmLikelyAutomated(): string;
    get sbfmStaticResourceProtection(): string;
    get sbfmVerifiedBots(): string;
    get suppressSessionScore(): cdktf.IResolvable;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/bot_management cloudflare_bot_management}
*/
export declare class DataCloudflareBotManagement extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_bot_management";
    /**
    * Generates CDKTF code for importing a DataCloudflareBotManagement resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareBotManagement to import
    * @param importFromId The id of the existing DataCloudflareBotManagement that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/bot_management#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareBotManagement to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/bot_management cloudflare_bot_management} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareBotManagementConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareBotManagementConfig);
    get aiBotsProtection(): string;
    get autoUpdateModel(): cdktf.IResolvable;
    get crawlerProtection(): string;
    get enableJs(): cdktf.IResolvable;
    get fightMode(): cdktf.IResolvable;
    get optimizeWordpress(): cdktf.IResolvable;
    get sbfmDefinitelyAutomated(): string;
    get sbfmLikelyAutomated(): string;
    get sbfmStaticResourceProtection(): cdktf.IResolvable;
    get sbfmVerifiedBots(): string;
    private _staleZoneConfiguration;
    get staleZoneConfiguration(): DataCloudflareBotManagementStaleZoneConfigurationOutputReference;
    get suppressSessionScore(): cdktf.IResolvable;
    get usingLatestModel(): cdktf.IResolvable;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
