/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareMagicWanGreTunnelConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifier
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/magic_wan_gre_tunnel#account_id DataCloudflareMagicWanGreTunnel#account_id}
    */
    readonly accountId: string;
    /**
    * Identifier
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/magic_wan_gre_tunnel#gre_tunnel_id DataCloudflareMagicWanGreTunnel#gre_tunnel_id}
    */
    readonly greTunnelId: string;
}
export interface DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTarget {
}
export declare function dataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTargetToTerraform(struct?: DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTarget): any;
export declare function dataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTargetToHclTerraform(struct?: DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTarget): any;
export declare class DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTarget | undefined;
    set internalValue(value: DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTarget | undefined);
    get effective(): string;
    get saved(): string;
}
export interface DataCloudflareMagicWanGreTunnelGreTunnelHealthCheck {
}
export declare function dataCloudflareMagicWanGreTunnelGreTunnelHealthCheckToTerraform(struct?: DataCloudflareMagicWanGreTunnelGreTunnelHealthCheck): any;
export declare function dataCloudflareMagicWanGreTunnelGreTunnelHealthCheckToHclTerraform(struct?: DataCloudflareMagicWanGreTunnelGreTunnelHealthCheck): any;
export declare class DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareMagicWanGreTunnelGreTunnelHealthCheck | undefined;
    set internalValue(value: DataCloudflareMagicWanGreTunnelGreTunnelHealthCheck | undefined);
    get direction(): string;
    get enabled(): cdktf.IResolvable;
    get rate(): string;
    private _target;
    get target(): DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckTargetOutputReference;
    get type(): string;
}
export interface DataCloudflareMagicWanGreTunnelGreTunnel {
}
export declare function dataCloudflareMagicWanGreTunnelGreTunnelToTerraform(struct?: DataCloudflareMagicWanGreTunnelGreTunnel): any;
export declare function dataCloudflareMagicWanGreTunnelGreTunnelToHclTerraform(struct?: DataCloudflareMagicWanGreTunnelGreTunnel): any;
export declare class DataCloudflareMagicWanGreTunnelGreTunnelOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareMagicWanGreTunnelGreTunnel | undefined;
    set internalValue(value: DataCloudflareMagicWanGreTunnelGreTunnel | undefined);
    get cloudflareGreEndpoint(): string;
    get createdOn(): string;
    get customerGreEndpoint(): string;
    get description(): string;
    private _healthCheck;
    get healthCheck(): DataCloudflareMagicWanGreTunnelGreTunnelHealthCheckOutputReference;
    get id(): string;
    get interfaceAddress(): string;
    get modifiedOn(): string;
    get mtu(): number;
    get name(): string;
    get ttl(): number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/magic_wan_gre_tunnel cloudflare_magic_wan_gre_tunnel}
*/
export declare class DataCloudflareMagicWanGreTunnel extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_magic_wan_gre_tunnel";
    /**
    * Generates CDKTF code for importing a DataCloudflareMagicWanGreTunnel resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareMagicWanGreTunnel to import
    * @param importFromId The id of the existing DataCloudflareMagicWanGreTunnel that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/magic_wan_gre_tunnel#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareMagicWanGreTunnel to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/magic_wan_gre_tunnel cloudflare_magic_wan_gre_tunnel} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareMagicWanGreTunnelConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareMagicWanGreTunnelConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _greTunnel;
    get greTunnel(): DataCloudflareMagicWanGreTunnelGreTunnelOutputReference;
    private _greTunnelId?;
    get greTunnelId(): string;
    set greTunnelId(value: string);
    get greTunnelIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
