/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflarePagesProjectsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifier
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/pages_projects#account_id DataCloudflarePagesProjects#account_id}
    */
    readonly accountId: string;
    /**
    * Max items to fetch, default: 1000
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/pages_projects#max_items DataCloudflarePagesProjects#max_items}
    */
    readonly maxItems?: number;
}
export interface DataCloudflarePagesProjectsResultBuildConfig {
}
export declare function dataCloudflarePagesProjectsResultBuildConfigToTerraform(struct?: DataCloudflarePagesProjectsResultBuildConfig): any;
export declare function dataCloudflarePagesProjectsResultBuildConfigToHclTerraform(struct?: DataCloudflarePagesProjectsResultBuildConfig): any;
export declare class DataCloudflarePagesProjectsResultBuildConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflarePagesProjectsResultBuildConfig | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultBuildConfig | undefined);
    get buildCaching(): cdktf.IResolvable;
    get buildCommand(): string;
    get destinationDir(): string;
    get rootDir(): string;
    get webAnalyticsTag(): string;
    get webAnalyticsToken(): string;
}
export interface DataCloudflarePagesProjectsResultDeploymentTriggerMetadata {
}
export declare function dataCloudflarePagesProjectsResultDeploymentTriggerMetadataToTerraform(struct?: DataCloudflarePagesProjectsResultDeploymentTriggerMetadata): any;
export declare function dataCloudflarePagesProjectsResultDeploymentTriggerMetadataToHclTerraform(struct?: DataCloudflarePagesProjectsResultDeploymentTriggerMetadata): any;
export declare class DataCloudflarePagesProjectsResultDeploymentTriggerMetadataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflarePagesProjectsResultDeploymentTriggerMetadata | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultDeploymentTriggerMetadata | undefined);
    get branch(): string;
    get commitHash(): string;
    get commitMessage(): string;
}
export interface DataCloudflarePagesProjectsResultDeploymentTrigger {
}
export declare function dataCloudflarePagesProjectsResultDeploymentTriggerToTerraform(struct?: DataCloudflarePagesProjectsResultDeploymentTrigger): any;
export declare function dataCloudflarePagesProjectsResultDeploymentTriggerToHclTerraform(struct?: DataCloudflarePagesProjectsResultDeploymentTrigger): any;
export declare class DataCloudflarePagesProjectsResultDeploymentTriggerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflarePagesProjectsResultDeploymentTrigger | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultDeploymentTrigger | undefined);
    private _metadata;
    get metadata(): DataCloudflarePagesProjectsResultDeploymentTriggerMetadataOutputReference;
    get type(): string;
}
export interface DataCloudflarePagesProjectsResultEnvVars {
}
export declare function dataCloudflarePagesProjectsResultEnvVarsToTerraform(struct?: DataCloudflarePagesProjectsResultEnvVars): any;
export declare function dataCloudflarePagesProjectsResultEnvVarsToHclTerraform(struct?: DataCloudflarePagesProjectsResultEnvVars): any;
export declare class DataCloudflarePagesProjectsResultEnvVarsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectKey the key of this item in the map
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectKey: string);
    get internalValue(): DataCloudflarePagesProjectsResultEnvVars | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultEnvVars | undefined);
    get type(): string;
    get value(): string;
}
export declare class DataCloudflarePagesProjectsResultEnvVarsMap extends cdktf.ComplexMap {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    /**
    * @param key the key of the item to return
    */
    get(key: string): DataCloudflarePagesProjectsResultEnvVarsOutputReference;
}
export interface DataCloudflarePagesProjectsResultLatestStage {
}
export declare function dataCloudflarePagesProjectsResultLatestStageToTerraform(struct?: DataCloudflarePagesProjectsResultLatestStage): any;
export declare function dataCloudflarePagesProjectsResultLatestStageToHclTerraform(struct?: DataCloudflarePagesProjectsResultLatestStage): any;
export declare class DataCloudflarePagesProjectsResultLatestStageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflarePagesProjectsResultLatestStage | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultLatestStage | undefined);
    get endedOn(): string;
    get name(): string;
    get startedOn(): string;
    get status(): string;
}
export interface DataCloudflarePagesProjectsResultSourceConfig {
}
export declare function dataCloudflarePagesProjectsResultSourceConfigToTerraform(struct?: DataCloudflarePagesProjectsResultSourceConfig): any;
export declare function dataCloudflarePagesProjectsResultSourceConfigToHclTerraform(struct?: DataCloudflarePagesProjectsResultSourceConfig): any;
export declare class DataCloudflarePagesProjectsResultSourceConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflarePagesProjectsResultSourceConfig | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultSourceConfig | undefined);
    get deploymentsEnabled(): cdktf.IResolvable;
    get owner(): string;
    get pathExcludes(): string[];
    get pathIncludes(): string[];
    get prCommentsEnabled(): cdktf.IResolvable;
    get previewBranchExcludes(): string[];
    get previewBranchIncludes(): string[];
    get previewDeploymentSetting(): string;
    get productionBranch(): string;
    get productionDeploymentsEnabled(): cdktf.IResolvable;
    get repoName(): string;
}
export interface DataCloudflarePagesProjectsResultSource {
}
export declare function dataCloudflarePagesProjectsResultSourceToTerraform(struct?: DataCloudflarePagesProjectsResultSource): any;
export declare function dataCloudflarePagesProjectsResultSourceToHclTerraform(struct?: DataCloudflarePagesProjectsResultSource): any;
export declare class DataCloudflarePagesProjectsResultSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflarePagesProjectsResultSource | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultSource | undefined);
    private _config;
    get config(): DataCloudflarePagesProjectsResultSourceConfigOutputReference;
    get type(): string;
}
export interface DataCloudflarePagesProjectsResultStages {
}
export declare function dataCloudflarePagesProjectsResultStagesToTerraform(struct?: DataCloudflarePagesProjectsResultStages): any;
export declare function dataCloudflarePagesProjectsResultStagesToHclTerraform(struct?: DataCloudflarePagesProjectsResultStages): any;
export declare class DataCloudflarePagesProjectsResultStagesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflarePagesProjectsResultStages | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResultStages | undefined);
    get endedOn(): string;
    get name(): string;
    get startedOn(): string;
    get status(): string;
}
export declare class DataCloudflarePagesProjectsResultStagesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflarePagesProjectsResultStagesOutputReference;
}
export interface DataCloudflarePagesProjectsResult {
}
export declare function dataCloudflarePagesProjectsResultToTerraform(struct?: DataCloudflarePagesProjectsResult): any;
export declare function dataCloudflarePagesProjectsResultToHclTerraform(struct?: DataCloudflarePagesProjectsResult): any;
export declare class DataCloudflarePagesProjectsResultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflarePagesProjectsResult | undefined;
    set internalValue(value: DataCloudflarePagesProjectsResult | undefined);
    get aliases(): string[];
    private _buildConfig;
    get buildConfig(): DataCloudflarePagesProjectsResultBuildConfigOutputReference;
    get createdOn(): string;
    private _deploymentTrigger;
    get deploymentTrigger(): DataCloudflarePagesProjectsResultDeploymentTriggerOutputReference;
    private _envVars;
    get envVars(): DataCloudflarePagesProjectsResultEnvVarsMap;
    get environment(): string;
    get id(): string;
    get isSkipped(): cdktf.IResolvable;
    private _latestStage;
    get latestStage(): DataCloudflarePagesProjectsResultLatestStageOutputReference;
    get modifiedOn(): string;
    get projectId(): string;
    get projectName(): string;
    get shortId(): string;
    private _source;
    get source(): DataCloudflarePagesProjectsResultSourceOutputReference;
    private _stages;
    get stages(): DataCloudflarePagesProjectsResultStagesList;
    get url(): string;
}
export declare class DataCloudflarePagesProjectsResultList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflarePagesProjectsResultOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/pages_projects cloudflare_pages_projects}
*/
export declare class DataCloudflarePagesProjects extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_pages_projects";
    /**
    * Generates CDKTF code for importing a DataCloudflarePagesProjects resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflarePagesProjects to import
    * @param importFromId The id of the existing DataCloudflarePagesProjects that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/pages_projects#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflarePagesProjects to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/pages_projects cloudflare_pages_projects} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflarePagesProjectsConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflarePagesProjectsConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _maxItems?;
    get maxItems(): number;
    set maxItems(value: number);
    resetMaxItems(): void;
    get maxItemsInput(): number | undefined;
    private _result;
    get result(): DataCloudflarePagesProjectsResultList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
