/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareWorkersDeploymentConfig extends cdktf.TerraformMetaArguments {
    /**
    * Identifier.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/workers_deployment#account_id DataCloudflareWorkersDeployment#account_id}
    */
    readonly accountId: string;
    /**
    * Name of the script.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/workers_deployment#script_name DataCloudflareWorkersDeployment#script_name}
    */
    readonly scriptName: string;
}
export interface DataCloudflareWorkersDeploymentDeploymentsAnnotations {
}
export declare function dataCloudflareWorkersDeploymentDeploymentsAnnotationsToTerraform(struct?: DataCloudflareWorkersDeploymentDeploymentsAnnotations): any;
export declare function dataCloudflareWorkersDeploymentDeploymentsAnnotationsToHclTerraform(struct?: DataCloudflareWorkersDeploymentDeploymentsAnnotations): any;
export declare class DataCloudflareWorkersDeploymentDeploymentsAnnotationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareWorkersDeploymentDeploymentsAnnotations | undefined;
    set internalValue(value: DataCloudflareWorkersDeploymentDeploymentsAnnotations | undefined);
    get workersMessage(): string;
}
export interface DataCloudflareWorkersDeploymentDeploymentsVersions {
}
export declare function dataCloudflareWorkersDeploymentDeploymentsVersionsToTerraform(struct?: DataCloudflareWorkersDeploymentDeploymentsVersions): any;
export declare function dataCloudflareWorkersDeploymentDeploymentsVersionsToHclTerraform(struct?: DataCloudflareWorkersDeploymentDeploymentsVersions): any;
export declare class DataCloudflareWorkersDeploymentDeploymentsVersionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareWorkersDeploymentDeploymentsVersions | undefined;
    set internalValue(value: DataCloudflareWorkersDeploymentDeploymentsVersions | undefined);
    get percentage(): number;
    get versionId(): string;
}
export declare class DataCloudflareWorkersDeploymentDeploymentsVersionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareWorkersDeploymentDeploymentsVersionsOutputReference;
}
export interface DataCloudflareWorkersDeploymentDeployments {
}
export declare function dataCloudflareWorkersDeploymentDeploymentsToTerraform(struct?: DataCloudflareWorkersDeploymentDeployments): any;
export declare function dataCloudflareWorkersDeploymentDeploymentsToHclTerraform(struct?: DataCloudflareWorkersDeploymentDeployments): any;
export declare class DataCloudflareWorkersDeploymentDeploymentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareWorkersDeploymentDeployments | undefined;
    set internalValue(value: DataCloudflareWorkersDeploymentDeployments | undefined);
    private _annotations;
    get annotations(): DataCloudflareWorkersDeploymentDeploymentsAnnotationsOutputReference;
    get authorEmail(): string;
    get createdOn(): string;
    get id(): string;
    get source(): string;
    get strategy(): string;
    private _versions;
    get versions(): DataCloudflareWorkersDeploymentDeploymentsVersionsList;
}
export declare class DataCloudflareWorkersDeploymentDeploymentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareWorkersDeploymentDeploymentsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/workers_deployment cloudflare_workers_deployment}
*/
export declare class DataCloudflareWorkersDeployment extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_workers_deployment";
    /**
    * Generates CDKTF code for importing a DataCloudflareWorkersDeployment resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareWorkersDeployment to import
    * @param importFromId The id of the existing DataCloudflareWorkersDeployment that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/workers_deployment#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareWorkersDeployment to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/workers_deployment cloudflare_workers_deployment} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareWorkersDeploymentConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareWorkersDeploymentConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _deployments;
    get deployments(): DataCloudflareWorkersDeploymentDeploymentsList;
    private _scriptName?;
    get scriptName(): string;
    set scriptName(value: string);
    get scriptNameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
