/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareZeroTrustDlpCustomProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_custom_profile#account_id DataCloudflareZeroTrustDlpCustomProfile#account_id}
    */
    readonly accountId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_custom_profile#profile_id DataCloudflareZeroTrustDlpCustomProfile#profile_id}
    */
    readonly profileId: string;
}
export interface DataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkip {
}
export declare function dataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkipToTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkip): any;
export declare function dataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkipToHclTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkip): any;
export declare class DataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkipOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkip | undefined;
    set internalValue(value: DataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkip | undefined);
    get files(): cdktf.IResolvable;
}
export interface DataCloudflareZeroTrustDlpCustomProfileContextAwareness {
}
export declare function dataCloudflareZeroTrustDlpCustomProfileContextAwarenessToTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileContextAwareness): any;
export declare function dataCloudflareZeroTrustDlpCustomProfileContextAwarenessToHclTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileContextAwareness): any;
export declare class DataCloudflareZeroTrustDlpCustomProfileContextAwarenessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareZeroTrustDlpCustomProfileContextAwareness | undefined;
    set internalValue(value: DataCloudflareZeroTrustDlpCustomProfileContextAwareness | undefined);
    get enabled(): cdktf.IResolvable;
    private _skip;
    get skip(): DataCloudflareZeroTrustDlpCustomProfileContextAwarenessSkipOutputReference;
}
export interface DataCloudflareZeroTrustDlpCustomProfileEntriesConfidence {
}
export declare function dataCloudflareZeroTrustDlpCustomProfileEntriesConfidenceToTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileEntriesConfidence): any;
export declare function dataCloudflareZeroTrustDlpCustomProfileEntriesConfidenceToHclTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileEntriesConfidence): any;
export declare class DataCloudflareZeroTrustDlpCustomProfileEntriesConfidenceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareZeroTrustDlpCustomProfileEntriesConfidence | undefined;
    set internalValue(value: DataCloudflareZeroTrustDlpCustomProfileEntriesConfidence | undefined);
    get aiContextAvailable(): cdktf.IResolvable;
    get available(): cdktf.IResolvable;
}
export interface DataCloudflareZeroTrustDlpCustomProfileEntriesPattern {
}
export declare function dataCloudflareZeroTrustDlpCustomProfileEntriesPatternToTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileEntriesPattern): any;
export declare function dataCloudflareZeroTrustDlpCustomProfileEntriesPatternToHclTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileEntriesPattern): any;
export declare class DataCloudflareZeroTrustDlpCustomProfileEntriesPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareZeroTrustDlpCustomProfileEntriesPattern | undefined;
    set internalValue(value: DataCloudflareZeroTrustDlpCustomProfileEntriesPattern | undefined);
    get regex(): string;
    get validation(): string;
}
export interface DataCloudflareZeroTrustDlpCustomProfileEntries {
}
export declare function dataCloudflareZeroTrustDlpCustomProfileEntriesToTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileEntries): any;
export declare function dataCloudflareZeroTrustDlpCustomProfileEntriesToHclTerraform(struct?: DataCloudflareZeroTrustDlpCustomProfileEntries): any;
export declare class DataCloudflareZeroTrustDlpCustomProfileEntriesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareZeroTrustDlpCustomProfileEntries | undefined;
    set internalValue(value: DataCloudflareZeroTrustDlpCustomProfileEntries | undefined);
    get caseSensitive(): cdktf.IResolvable;
    private _confidence;
    get confidence(): DataCloudflareZeroTrustDlpCustomProfileEntriesConfidenceOutputReference;
    get createdAt(): string;
    get enabled(): cdktf.IResolvable;
    get id(): string;
    get name(): string;
    private _pattern;
    get pattern(): DataCloudflareZeroTrustDlpCustomProfileEntriesPatternOutputReference;
    get profileId(): string;
    get secret(): cdktf.IResolvable;
    get type(): string;
    get updatedAt(): string;
    get wordList(): string;
}
export declare class DataCloudflareZeroTrustDlpCustomProfileEntriesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareZeroTrustDlpCustomProfileEntriesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_custom_profile cloudflare_zero_trust_dlp_custom_profile}
*/
export declare class DataCloudflareZeroTrustDlpCustomProfile extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_zero_trust_dlp_custom_profile";
    /**
    * Generates CDKTF code for importing a DataCloudflareZeroTrustDlpCustomProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareZeroTrustDlpCustomProfile to import
    * @param importFromId The id of the existing DataCloudflareZeroTrustDlpCustomProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_custom_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareZeroTrustDlpCustomProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_custom_profile cloudflare_zero_trust_dlp_custom_profile} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareZeroTrustDlpCustomProfileConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareZeroTrustDlpCustomProfileConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    get aiContextEnabled(): cdktf.IResolvable;
    get allowedMatchCount(): number;
    get confidenceThreshold(): string;
    private _contextAwareness;
    get contextAwareness(): DataCloudflareZeroTrustDlpCustomProfileContextAwarenessOutputReference;
    get createdAt(): string;
    get description(): string;
    private _entries;
    get entries(): DataCloudflareZeroTrustDlpCustomProfileEntriesList;
    get id(): string;
    get name(): string;
    get ocrEnabled(): cdktf.IResolvable;
    get openAccess(): cdktf.IResolvable;
    private _profileId?;
    get profileId(): string;
    set profileId(value: string);
    get profileIdInput(): string | undefined;
    get type(): string;
    get updatedAt(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
