/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareZeroTrustDlpEntryConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_entry#account_id DataCloudflareZeroTrustDlpEntry#account_id}
    */
    readonly accountId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_entry#entry_id DataCloudflareZeroTrustDlpEntry#entry_id}
    */
    readonly entryId?: string;
}
export interface DataCloudflareZeroTrustDlpEntryConfidence {
}
export declare function dataCloudflareZeroTrustDlpEntryConfidenceToTerraform(struct?: DataCloudflareZeroTrustDlpEntryConfidence): any;
export declare function dataCloudflareZeroTrustDlpEntryConfidenceToHclTerraform(struct?: DataCloudflareZeroTrustDlpEntryConfidence): any;
export declare class DataCloudflareZeroTrustDlpEntryConfidenceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareZeroTrustDlpEntryConfidence | undefined;
    set internalValue(value: DataCloudflareZeroTrustDlpEntryConfidence | undefined);
    get aiContextAvailable(): cdktf.IResolvable;
    get available(): cdktf.IResolvable;
}
export interface DataCloudflareZeroTrustDlpEntryPattern {
}
export declare function dataCloudflareZeroTrustDlpEntryPatternToTerraform(struct?: DataCloudflareZeroTrustDlpEntryPattern): any;
export declare function dataCloudflareZeroTrustDlpEntryPatternToHclTerraform(struct?: DataCloudflareZeroTrustDlpEntryPattern): any;
export declare class DataCloudflareZeroTrustDlpEntryPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareZeroTrustDlpEntryPattern | undefined;
    set internalValue(value: DataCloudflareZeroTrustDlpEntryPattern | undefined);
    get regex(): string;
    get validation(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_entry cloudflare_zero_trust_dlp_entry}
*/
export declare class DataCloudflareZeroTrustDlpEntry extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_zero_trust_dlp_entry";
    /**
    * Generates CDKTF code for importing a DataCloudflareZeroTrustDlpEntry resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareZeroTrustDlpEntry to import
    * @param importFromId The id of the existing DataCloudflareZeroTrustDlpEntry that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_entry#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareZeroTrustDlpEntry to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/data-sources/zero_trust_dlp_entry cloudflare_zero_trust_dlp_entry} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareZeroTrustDlpEntryConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareZeroTrustDlpEntryConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    get caseSensitive(): cdktf.IResolvable;
    private _confidence;
    get confidence(): DataCloudflareZeroTrustDlpEntryConfidenceOutputReference;
    get createdAt(): string;
    get enabled(): cdktf.IResolvable;
    private _entryId?;
    get entryId(): string;
    set entryId(value: string);
    resetEntryId(): void;
    get entryIdInput(): string | undefined;
    get id(): string;
    get name(): string;
    private _pattern;
    get pattern(): DataCloudflareZeroTrustDlpEntryPatternOutputReference;
    get profileId(): string;
    get secret(): cdktf.IResolvable;
    get type(): string;
    get updatedAt(): string;
    get wordList(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
