/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ObservatoryScheduledTestConfig extends cdktf.TerraformMetaArguments {
    /**
    * A URL.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/observatory_scheduled_test#url ObservatoryScheduledTest#url}
    */
    readonly url: string;
    /**
    * Identifier.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/observatory_scheduled_test#zone_id ObservatoryScheduledTest#zone_id}
    */
    readonly zoneId: string;
}
export interface ObservatoryScheduledTestSchedule {
}
export declare function observatoryScheduledTestScheduleToTerraform(struct?: ObservatoryScheduledTestSchedule): any;
export declare function observatoryScheduledTestScheduleToHclTerraform(struct?: ObservatoryScheduledTestSchedule): any;
export declare class ObservatoryScheduledTestScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObservatoryScheduledTestSchedule | undefined;
    set internalValue(value: ObservatoryScheduledTestSchedule | undefined);
    get frequency(): string;
    get region(): string;
    get url(): string;
}
export interface ObservatoryScheduledTestTestDesktopReportError {
}
export declare function observatoryScheduledTestTestDesktopReportErrorToTerraform(struct?: ObservatoryScheduledTestTestDesktopReportError): any;
export declare function observatoryScheduledTestTestDesktopReportErrorToHclTerraform(struct?: ObservatoryScheduledTestTestDesktopReportError): any;
export declare class ObservatoryScheduledTestTestDesktopReportErrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObservatoryScheduledTestTestDesktopReportError | undefined;
    set internalValue(value: ObservatoryScheduledTestTestDesktopReportError | undefined);
    get code(): string;
    get detail(): string;
    get finalDisplayedUrl(): string;
}
export interface ObservatoryScheduledTestTestDesktopReport {
}
export declare function observatoryScheduledTestTestDesktopReportToTerraform(struct?: ObservatoryScheduledTestTestDesktopReport): any;
export declare function observatoryScheduledTestTestDesktopReportToHclTerraform(struct?: ObservatoryScheduledTestTestDesktopReport): any;
export declare class ObservatoryScheduledTestTestDesktopReportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObservatoryScheduledTestTestDesktopReport | undefined;
    set internalValue(value: ObservatoryScheduledTestTestDesktopReport | undefined);
    get cls(): number;
    get deviceType(): string;
    private _error;
    get error(): ObservatoryScheduledTestTestDesktopReportErrorOutputReference;
    get fcp(): number;
    get jsonReportUrl(): string;
    get lcp(): number;
    get performanceScore(): number;
    get si(): number;
    get state(): string;
    get tbt(): number;
    get ttfb(): number;
    get tti(): number;
}
export interface ObservatoryScheduledTestTestMobileReportError {
}
export declare function observatoryScheduledTestTestMobileReportErrorToTerraform(struct?: ObservatoryScheduledTestTestMobileReportError): any;
export declare function observatoryScheduledTestTestMobileReportErrorToHclTerraform(struct?: ObservatoryScheduledTestTestMobileReportError): any;
export declare class ObservatoryScheduledTestTestMobileReportErrorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObservatoryScheduledTestTestMobileReportError | undefined;
    set internalValue(value: ObservatoryScheduledTestTestMobileReportError | undefined);
    get code(): string;
    get detail(): string;
    get finalDisplayedUrl(): string;
}
export interface ObservatoryScheduledTestTestMobileReport {
}
export declare function observatoryScheduledTestTestMobileReportToTerraform(struct?: ObservatoryScheduledTestTestMobileReport): any;
export declare function observatoryScheduledTestTestMobileReportToHclTerraform(struct?: ObservatoryScheduledTestTestMobileReport): any;
export declare class ObservatoryScheduledTestTestMobileReportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObservatoryScheduledTestTestMobileReport | undefined;
    set internalValue(value: ObservatoryScheduledTestTestMobileReport | undefined);
    get cls(): number;
    get deviceType(): string;
    private _error;
    get error(): ObservatoryScheduledTestTestMobileReportErrorOutputReference;
    get fcp(): number;
    get jsonReportUrl(): string;
    get lcp(): number;
    get performanceScore(): number;
    get si(): number;
    get state(): string;
    get tbt(): number;
    get ttfb(): number;
    get tti(): number;
}
export interface ObservatoryScheduledTestTestRegion {
}
export declare function observatoryScheduledTestTestRegionToTerraform(struct?: ObservatoryScheduledTestTestRegion): any;
export declare function observatoryScheduledTestTestRegionToHclTerraform(struct?: ObservatoryScheduledTestTestRegion): any;
export declare class ObservatoryScheduledTestTestRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObservatoryScheduledTestTestRegion | undefined;
    set internalValue(value: ObservatoryScheduledTestTestRegion | undefined);
    get label(): string;
    get value(): string;
}
export interface ObservatoryScheduledTestTest {
}
export declare function observatoryScheduledTestTestToTerraform(struct?: ObservatoryScheduledTestTest): any;
export declare function observatoryScheduledTestTestToHclTerraform(struct?: ObservatoryScheduledTestTest): any;
export declare class ObservatoryScheduledTestTestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ObservatoryScheduledTestTest | undefined;
    set internalValue(value: ObservatoryScheduledTestTest | undefined);
    get date(): string;
    private _desktopReport;
    get desktopReport(): ObservatoryScheduledTestTestDesktopReportOutputReference;
    get id(): string;
    private _mobileReport;
    get mobileReport(): ObservatoryScheduledTestTestMobileReportOutputReference;
    private _region;
    get region(): ObservatoryScheduledTestTestRegionOutputReference;
    get scheduleFrequency(): string;
    get url(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/observatory_scheduled_test cloudflare_observatory_scheduled_test}
*/
export declare class ObservatoryScheduledTest extends cdktf.TerraformResource {
    static readonly tfResourceType = "cloudflare_observatory_scheduled_test";
    /**
    * Generates CDKTF code for importing a ObservatoryScheduledTest resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ObservatoryScheduledTest to import
    * @param importFromId The id of the existing ObservatoryScheduledTest that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/observatory_scheduled_test#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ObservatoryScheduledTest to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/observatory_scheduled_test cloudflare_observatory_scheduled_test} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ObservatoryScheduledTestConfig
    */
    constructor(scope: Construct, id: string, config: ObservatoryScheduledTestConfig);
    get frequency(): string;
    get id(): string;
    get region(): string;
    private _schedule;
    get schedule(): ObservatoryScheduledTestScheduleOutputReference;
    private _test;
    get test(): ObservatoryScheduledTestTestOutputReference;
    private _url?;
    get url(): string;
    set url(value: string);
    get urlInput(): string | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
