/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ZeroTrustDlpPredefinedProfileConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#account_id ZeroTrustDlpPredefinedProfile#account_id}
    */
    readonly accountId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#ai_context_enabled ZeroTrustDlpPredefinedProfile#ai_context_enabled}
    */
    readonly aiContextEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#allowed_match_count ZeroTrustDlpPredefinedProfile#allowed_match_count}
    */
    readonly allowedMatchCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#confidence_threshold ZeroTrustDlpPredefinedProfile#confidence_threshold}
    */
    readonly confidenceThreshold?: string;
    /**
    * Scan the context of predefined entries to only return matches surrounded by keywords.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#context_awareness ZeroTrustDlpPredefinedProfile#context_awareness}
    */
    readonly contextAwareness?: ZeroTrustDlpPredefinedProfileContextAwareness;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#entries ZeroTrustDlpPredefinedProfile#entries}
    */
    readonly entries?: ZeroTrustDlpPredefinedProfileEntries[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#ocr_enabled ZeroTrustDlpPredefinedProfile#ocr_enabled}
    */
    readonly ocrEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#profile_id ZeroTrustDlpPredefinedProfile#profile_id}
    */
    readonly profileId: string;
}
export interface ZeroTrustDlpPredefinedProfileContextAwarenessSkip {
    /**
    * If the content type is a file, skip context analysis and return all matches.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#files ZeroTrustDlpPredefinedProfile#files}
    */
    readonly files: boolean | cdktf.IResolvable;
}
export declare function zeroTrustDlpPredefinedProfileContextAwarenessSkipToTerraform(struct?: ZeroTrustDlpPredefinedProfileContextAwarenessSkip | cdktf.IResolvable): any;
export declare function zeroTrustDlpPredefinedProfileContextAwarenessSkipToHclTerraform(struct?: ZeroTrustDlpPredefinedProfileContextAwarenessSkip | cdktf.IResolvable): any;
export declare class ZeroTrustDlpPredefinedProfileContextAwarenessSkipOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ZeroTrustDlpPredefinedProfileContextAwarenessSkip | cdktf.IResolvable | undefined;
    set internalValue(value: ZeroTrustDlpPredefinedProfileContextAwarenessSkip | cdktf.IResolvable | undefined);
    private _files?;
    get files(): boolean | cdktf.IResolvable;
    set files(value: boolean | cdktf.IResolvable);
    get filesInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ZeroTrustDlpPredefinedProfileContextAwareness {
    /**
    * If true, scan the context of predefined entries to only return matches surrounded by keywords.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#enabled ZeroTrustDlpPredefinedProfile#enabled}
    */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
    * Content types to exclude from context analysis and return all matches.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#skip ZeroTrustDlpPredefinedProfile#skip}
    */
    readonly skip: ZeroTrustDlpPredefinedProfileContextAwarenessSkip;
}
export declare function zeroTrustDlpPredefinedProfileContextAwarenessToTerraform(struct?: ZeroTrustDlpPredefinedProfileContextAwareness | cdktf.IResolvable): any;
export declare function zeroTrustDlpPredefinedProfileContextAwarenessToHclTerraform(struct?: ZeroTrustDlpPredefinedProfileContextAwareness | cdktf.IResolvable): any;
export declare class ZeroTrustDlpPredefinedProfileContextAwarenessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ZeroTrustDlpPredefinedProfileContextAwareness | cdktf.IResolvable | undefined;
    set internalValue(value: ZeroTrustDlpPredefinedProfileContextAwareness | cdktf.IResolvable | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _skip;
    get skip(): ZeroTrustDlpPredefinedProfileContextAwarenessSkipOutputReference;
    putSkip(value: ZeroTrustDlpPredefinedProfileContextAwarenessSkip): void;
    get skipInput(): cdktf.IResolvable | ZeroTrustDlpPredefinedProfileContextAwarenessSkip | undefined;
}
export interface ZeroTrustDlpPredefinedProfileEntries {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#enabled ZeroTrustDlpPredefinedProfile#enabled}
    */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#id ZeroTrustDlpPredefinedProfile#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
}
export declare function zeroTrustDlpPredefinedProfileEntriesToTerraform(struct?: ZeroTrustDlpPredefinedProfileEntries | cdktf.IResolvable): any;
export declare function zeroTrustDlpPredefinedProfileEntriesToHclTerraform(struct?: ZeroTrustDlpPredefinedProfileEntries | cdktf.IResolvable): any;
export declare class ZeroTrustDlpPredefinedProfileEntriesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ZeroTrustDlpPredefinedProfileEntries | cdktf.IResolvable | undefined;
    set internalValue(value: ZeroTrustDlpPredefinedProfileEntries | cdktf.IResolvable | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
}
export declare class ZeroTrustDlpPredefinedProfileEntriesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ZeroTrustDlpPredefinedProfileEntries[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ZeroTrustDlpPredefinedProfileEntriesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile cloudflare_zero_trust_dlp_predefined_profile}
*/
export declare class ZeroTrustDlpPredefinedProfile extends cdktf.TerraformResource {
    static readonly tfResourceType = "cloudflare_zero_trust_dlp_predefined_profile";
    /**
    * Generates CDKTF code for importing a ZeroTrustDlpPredefinedProfile resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ZeroTrustDlpPredefinedProfile to import
    * @param importFromId The id of the existing ZeroTrustDlpPredefinedProfile that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ZeroTrustDlpPredefinedProfile to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/5.6.0/docs/resources/zero_trust_dlp_predefined_profile cloudflare_zero_trust_dlp_predefined_profile} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ZeroTrustDlpPredefinedProfileConfig
    */
    constructor(scope: Construct, id: string, config: ZeroTrustDlpPredefinedProfileConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _aiContextEnabled?;
    get aiContextEnabled(): boolean | cdktf.IResolvable;
    set aiContextEnabled(value: boolean | cdktf.IResolvable);
    resetAiContextEnabled(): void;
    get aiContextEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _allowedMatchCount?;
    get allowedMatchCount(): number;
    set allowedMatchCount(value: number);
    resetAllowedMatchCount(): void;
    get allowedMatchCountInput(): number | undefined;
    private _confidenceThreshold?;
    get confidenceThreshold(): string;
    set confidenceThreshold(value: string);
    resetConfidenceThreshold(): void;
    get confidenceThresholdInput(): string | undefined;
    private _contextAwareness;
    get contextAwareness(): ZeroTrustDlpPredefinedProfileContextAwarenessOutputReference;
    putContextAwareness(value: ZeroTrustDlpPredefinedProfileContextAwareness): void;
    resetContextAwareness(): void;
    get contextAwarenessInput(): cdktf.IResolvable | ZeroTrustDlpPredefinedProfileContextAwareness | undefined;
    get createdAt(): string;
    get description(): string;
    private _entries;
    get entries(): ZeroTrustDlpPredefinedProfileEntriesList;
    putEntries(value: ZeroTrustDlpPredefinedProfileEntries[] | cdktf.IResolvable): void;
    resetEntries(): void;
    get entriesInput(): cdktf.IResolvable | ZeroTrustDlpPredefinedProfileEntries[] | undefined;
    get id(): string;
    get name(): string;
    private _ocrEnabled?;
    get ocrEnabled(): boolean | cdktf.IResolvable;
    set ocrEnabled(value: boolean | cdktf.IResolvable);
    resetOcrEnabled(): void;
    get ocrEnabledInput(): boolean | cdktf.IResolvable | undefined;
    get openAccess(): cdktf.IResolvable;
    private _profileId?;
    get profileId(): string;
    set profileId(value: string);
    get profileIdInput(): string | undefined;
    get type(): string;
    get updatedAt(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
